#!/bin/bash
set -e

usage() {
    echo "Usage: $0 <srcdir> <destdir> [owner]" > /dev/stderr
    exit 1
}

die() {
    cleanup
    echo ERROR: $* > /dev/stderr
    exit 1
}

SRCDIR="$1"
DESTDIR="$2"
OWNER="$3"

[ "x$SRCDIR" = "x" ] && usage
[ "x$DESTDIR" = "x" ] && usage

echo "STARTING"

mkdir -p "$DESTDIR" || die "mkdir failed"

rsync -av "$SRCDIR/" "$DESTDIR/"

if [ "x$OWNER" != "x" ]; then
    chown -R "$OWNER" "$DESTDIR"
fi

chmod -R +rw "$DESTDIR"

echo
echo "INFO: Done"
echo
