#  Copyright (c) 2010 Vitja Makarov
#
#  Author: Vitja Makarov <vitja.makarov@gmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3,
# as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from uirk.progress.text import TextExecTaskProgress
from uirk import utils

class ExecTask(object):
    def __init__(self, args, verbose=False, message=False):
        """Runs system command 'command'"""
        self.args = args
        self.verbose = False
        self.message = message

    def run(self, progress=None):
        if progress is None:
            progress = TextExecTaskProgress
        progress = TextExecTaskProgress(obj=self, verbose=self.verbose, message=self.message)
        ret = progress.run(self, self.args[0], self.args)
        if ret != 0:
            raise utils.OperationError, "Task exited with %d error code" % ret
